<template lang="pug">
  centered-forty-sixty
    .columns
      .bio
        .markdown(v-show="profile.bio" v-html="bioHtml")
        .divider(v-if="profile.bio")
        small.text-gray.
          {{ $t('joined') | lowercase }} {{ $d(new Date(profile.createdAt), 'short') }}
    .columns
      dropdown-button(
        style="height:initial;position:relative;top:-0.25rem;left:-0.25rem;"
      ) {{ $tc(activityFilter, 2) | capitalize({ onlyFirstLetter: true }) }} #[i.material-icons(tabindex="-1" style="font-size:0.9rem;") filter_list]
        template(slot="container")
          li.menu-item
            a.menu-item(:class="{ active: activityFilter == 'comment' }" @click="() => activityFilter = 'comment'")
              small only show comments
          li.menu-item
            a.menu-item(:class="{ active: activityFilter == 'modification' }" @click="() => activityFilter = 'modification'")
              small only show modifications
          li.menu-item
            a.menu-item(:class="{ active: activityFilter == 'activity' }" @click="() => activityFilter = 'activity'")
              small show all
      .activities.mt-15
        activity.mb-25(v-for="action in activities" :activity="action" :key="action.pk")
      .empty-action.col-mx-auto.mb-20(v-if="false && actions && actions.pageInfo && actions.pageInfo.hasNextPage")
        z-button {{ $t('show more') }}
</template>

<script>
import { mapGetters } from 'vuex'

import snarkdown from 'snarkdown'

import CenteredFortySixty from '~/components/sublayouts/CenteredFortySixty.vue'
import Activity from '~/components/Activity'
import DropdownButton from '~/components/DropdownButton'

export default {
  layout: 'default+profileheader',
  components: {
    // layout components:
    CenteredFortySixty,
    // logic components:
    Activity,
    DropdownButton
  },
  data() {
    return {
      routeParam: this.$route.params.id.substring(1),
      profile: {
        bio: '',
        name: ''
      },
      activities: [],
      activityFilter: 'activity'
    }
  },
  head() {
    return {
      title: `${this.getInstanceName} - ${this.name}`,
      meta: [
        {
          hid: 'og:image',
          property: 'og:image',
          content: this.profile.avatar
        },
        {
          hid: 'og:description',
          property: 'og:description',
          content: this.displayName
        },
        this.crawlable ? {} : { name: 'robots', content: 'noindex, nofollow' }
      ],
      link: [
        // { rel: 'alternate', href='{{$profile->permalink()}}', type: 'application/activity+json' }
        {
          rel: 'alternate',
          href: `${this.$route.path}.rss`,
          title: `${this.name} on OLKi`,
          type: 'application/rss+xml'
        },
        {
          rel: 'alternate',
          href: `${this.$route.path}.atom`,
          title: `${this.name} on OLKi`,
          type: 'application/atom+xml'
        }
      ]
    }
  },
  computed: {
    bioHtml() {
      return snarkdown(this.profile.bio)
    },
    crawlable() {
      return this.profile && this.profile.indexed
    },
    ...mapGetters('instance', ['getInstanceName'])
  },
  asyncData({ store, params }) {
    store.commit('users/setCurrentUser', params.id.substring(1))
    return store.dispatch('users/getUserByUsername', params.id.substring(1))
  },
  async mounted() {
    this.activities = await this.$store.dispatch(
      'users/getUserActionsByUsername',
      this.actor.fid
    )
  }
}
</script>

<style scoped>
.columns {
  flex-direction: column;
  text-align: left;
}

.bio {
  background: rgb(var(--color-foreground));
  border-radius: 4px;
  margin-bottom: 25px;
  padding: 20px;
}
</style>
